%%
%%  This is file `thesis.cls',
%%   __________________________________
%%   Copyright © 2011-2012 Mohsen SHARIFI TABAR
%%   http://sharifitabar.com      
%% 
\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{thesis}[2011/10/08 v1.0]
\LoadClass[12pt,a4paper,BCOR=.7cm,headsepline,bibliography=totoc,openany]{scrbook}
\renewcommand\headfont{\small\itshape}
\renewcommand*\sectfont{\normalcolor\bfseries}
\newcommand{\D}{\displaystyle}
\DeclareOption{MsThesis}{\AtEndOfPackage{\def\@fordegree{\if@Latin Ms Thesis\else پایان‌نامه کارشناسی ارشد\fi}}}
\DeclareOption{BScThesis}{\AtEndOfPackage{\def\@fordegree{\if@Latin BSc Thesis\else پایان‌نامه کارشناسی\fi}}}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{scrbook}}
\ProcessOptions
\RequirePackage{amsmath,amsthm}
%حاشیه در اینجا مشخص می‌شود.
\newlength\OddM@rg
\if@twoside\def\sw@pmargs{\oddsidemargin\evensidemargin}\else
\def\sw@pmargs{\OddM@rg\paperwidth \addtolength\OddM@rg{-\textwidth}
    \addtolength\OddM@rg{-\oddsidemargin} \addtolength\OddM@rg{-2\hoffset} \addtolength\OddM@rg{-2in}
    \oddsidemargin\OddM@rg}
\sw@pmargs\fi
%در انتها بایستی فراخوانی شود
\def\PrepareForBackMatter{\cleardoubleemptypage\pagestyle{plain}\backmatter}
\def\PrepareForLatinPages{\cleardoubleemptypage\pagestyle{empty}\sw@pmargs\latin}
%صفحات چکیده و قدردانی
\newenvironment{abstract}[1]
    {\def\@keywds{#1}\cleardoubleemptypage\begin{center}\Large\bfseries\st@title\end{center}\subsection*{\@abstname}\begin{quote}}
    {\end{quote}\paragraph*{\@keywordsname:}{\@keywds.}\cleardoubleemptypage}
\newenvironment{قدردانی}
    {\cleardoubleemptypage\centerline{\Large\bfseries قدردانی}\begin{quote}}
    {\end{quote}\cleardoubleemptypage}
%صفحه تصویب
\def\referee#1#2{#1\ifx|#1|\else:\fi & {\large#2} & امضاء: . . . . . . . . . . .\\[1cm]}
\newenvironment{تصویب}{\def\BSkp{\par\vskip3\bigskipamount} \def\SSkp{\par\vskip\bigskipamount}
    \cleardoubleemptypage\begin{center}\large\bfseries به نام او\SSkp\st@university\end{center}
    \BSkp{\large\@fordegree}\SSkp
    \begin{tabular}{rr} عنوان: & {\large\st@title} \\[\medskipamount] \@by: & {\large\st@author} \end{tabular}
    \BSkp{\large کمیته داوران}\SSkp
    \begin{center}\begin{tabular*}{.9\textwidth}{r r @{\extracolsep{\fill}} l}
        \referee{\@undersup}{\st@supervisor}
        \ifdefined\st@secsupervisor\referee{}{\st@secsupervisor}\fi
        \ifdefined\st@advisor \referee{\@undercons}{\st@advisor}%
            \ifdefined\st@secadvisor \referee{}{\st@secadvisor}\fi%
        \fi%
}{
&& تاریخ: . . . . . . . . .
\end{tabular*}\end{center}}
%مشخصات پایان‌نامه
\let\origin@lmaketitle\maketitle
\def\makethesistitle{
    \def\@titlehead{\centering\st@logo\\\smallskip\large\st@university}
    \def\@title{\st@title}
    \def\@subject{\@fordegree\\\st@subject}
    \def\@author{{\normalsize\@by}\\{\st@author} \\[1.5\bigskipamount]%
        {\normalsize\@undersup}\\{\itshape\st@supervisor}\ifdefined\st@secsupervisor\ \if@Latin and \else و \fi{\itshape\st@secsupervisor}\fi%
        \ifdefined\st@advisor\\[1.5\bigskipamount]{\normalsize\@undercons}\\{\itshape\st@advisor}\ifdefined\st@secadvisor\ \if@Latin and \else و \fi{\itshape\st@secadvisor}\fi\fi
        \\[1.5\bigskipamount]}
    \def\@date{\ifdefined\st@date\st@date\else\if@Latin\latintoday\else\today\fi\fi}
    \origin@lmaketitle%
    \newcommand\date[1]{\def\st@date{##1}}%
    \newcommand\title[1]{\def\st@title{##1}}%
    \newcommand\author[1]{\def\st@author{##1}}%
    \newcommand\subject[1]{\def\st@subject{##1}}%
}
\renewcommand\date[1]{\def\st@date{#1}}
\renewcommand\title[1]{\def\st@title{#1}}
\renewcommand\author[1]{\def\st@author{#1}}
\renewcommand\subject[1]{\def\st@subject{#1}}
\newcommand\logo[1]{\def\st@logo{#1}}
\newcommand\university[1]{\def\st@university{#1}}
\newcommand\supervisor[1]{\def\st@supervisor{#1}}
\newcommand\secondsupervisor[1]{\def\st@secsupervisor{#1}}
\newcommand\advisor[1]{\def\st@advisor{#1}}
\newcommand\secondadvisor[1]{\def\st@secadvisor{#1}}
\def\@abstname{\if@Latin Abstract\else چکیده\fi}
\def\@keywordsname{\if@Latin Keywords\else واژه‌های کلیدی\fi}
\def\@undersup{\if@Latin Supervisor\ifdefined\st@secsupervisor s\fi\else\ifdefined\st@secsupervisor استادهای \else استاد \fi راهنما\fi}
\def\@undercons{\if@Latin Advisor\ifdefined\st@secadvisor s\fi\else\ifdefined\st@secadvisor استادهای \else استاد \fi مشاور\fi}
\def\@by{\if@Latin By\else نگارش\fi}
\def\@fordegree{\if@Latin PhD Thesis\else پایان‌نامه دکتری\fi}

\newtheorem{thm}{قضیه}[chapter]
\newtheorem{defi}{تعریف}[section]
\newtheorem{exm}{مثال}[section]


\AtBeginDocument{
    \eqcommand{دانشگاه}{university} \eqcommand{موضوع}{subject}
    \eqcommand{استادراهنما}{supervisor} \eqcommand{استادمشاور}{advisor}
    \eqcommand{استادراهنمادوم}{secondsupervisor} \eqcommand{استادمشاوردوم}{secondadvisor}
    \eqcommand{داور}{referee}\eqcommand{آرم}{logo} \eqcommand{تقدیم}{dedication}
    \eqenvironment{اثبات}{proof}\eqenvironment{قضیه}{theorem}
}

%% 
%% Copyright © 2011-2012      by Mohsen SHARIFI TABAR     
%% 
%% Distributable under the LaTeX Project Public License,
%% version 1.3c or higher (your choice). The latest version of this license is at: http://www.latex-project.org/lppl.txt
%% 
%% This work is "maintained" (as per LPPL maintenance status)
%% by Mohsen SHARIFI TABAR.
%% 
%% Special thanks to Vafa Khalighi for maintaining xepersian package.
%%
%% End of file `thesis.cls'.
